local me = CreateFrame("frame")

--See http://wowprogramming.com/docs/api_types#specID for what the IDs are
AutoLootSpecSwap_bossNameToSpecMapping = {
}

--0 means stay the same
AutoLootSpecSwap_specToSwitchToAfterLooting = 0

local autoSwapActive = false

me:RegisterEvent("PLAYER_TARGET_CHANGED")
me:RegisterEvent("LOOT_CLOSED")
local UnitName = _G["UnitName"]
local UnitIsDead = _G["UnitIsDead"]
me:SetScript("OnEvent", function(self, event)
	local newSpec = nil
	if(event == "PLAYER_TARGET_CHANGED") then
		if(not UnitIsDead("target")) then
			local targetName = UnitName("target")
			newSpec = AutoLootSpecSwap_bossNameToSpecMapping[targetName]
			if(newSpec) then
				inDefaultSpecAlready = false
				autoSwapActive = true
			end
		end
	elseif(autoSwapActive and (not (inDefaultSpecAlready or InCombatLockdown()))) then
		autoSwapActive = false
		if(AutoLootSpecSwap_specToSwitchToAfterLooting ~= 0) then
			newSpec = AutoLootSpecSwap_specToSwitchToAfterLooting
			inDefaultSpecAlready = true
		end
	end
	if(newSpec and ((GetLootSpecialization()) ~= newSpec)) then
		SetLootSpecialization(newSpec)
		print("AutoLootSpecSwap: CHANGED LOOT SPEC TO: <<"..(select(2,GetSpecializationInfoByID(newSpec)))..">>")
	end
end)

function me.SlashCommandHandler(cmd)
	if cmd and string.lower(cmd) == "record" then
		local currSpec = (GetLootSpecialization())
		local currTarget = UnitName("target")
		
		if(type(currSpec) == "number" and type(currTarget) == "string") then
			AutoLootSpecSwap_bossNameToSpecMapping[currTarget] = currSpec
			print("AutoLootSpecSwap: Recorded <<"..(select(2,GetSpecializationInfoByID(currSpec)))..">> as preferred spec for <<"..currTarget..">>.")
		end
	elseif cmd and string.lower(cmd) == "setdefault" then
		local currSpec = (GetLootSpecialization())
		if(type(currSpec) == "number") then
			AutoLootSpecSwap_specToSwitchToAfterLooting = currSpec
			print("AutoLootSpecSwap: Set default spec to <<"..(select(2,GetSpecializationInfoByID(currSpec)))..">>.")
		end
	elseif cmd and string.lower(cmd) == "list" then
		print("AutoLootSpecSwap: List")
		for k,v in pairs(AutoLootSpecSwap_bossNameToSpecMapping) do
			if(type(v) == "number" and type(k) == "string") then
				print(k..": "..(select(2,GetSpecializationInfoByID(v))))
			end
		end
		if(AutoLootSpecSwap_specToSwitchToAfterLooting) then
			if(AutoLootSpecSwap_specToSwitchToAfterLooting == 0) then
				print("Default: <<No default>>")
			else
				print("Default: "..(select(2,GetSpecializationInfoByID(AutoLootSpecSwap_specToSwitchToAfterLooting))))
			end
		end
	elseif cmd and string.lower(cmd) == "forget" then
		local currTarget = UnitName("target")
		if(type(currTarget) == "string") then
			AutoLootSpecSwap_bossNameToSpecMapping[currTarget] = nil
			print("AutoLootSpecSwap: Forgot target <<"..currTarget..">>.")
		end
	elseif cmd and string.lower(cmd) == "forgetdefault" then
		AutoLootSpecSwap_specToSwitchToAfterLooting = 0
		print("AutoLootSpecSwap: Forgot default spec.")
	else
		print("AutoLootSpecSwap: Usage:\n/alss record|setdefault|list|forget|forgetdefault")
	end
end

SlashCmdList["AUTOLOOTSPECSWAP"] = me.SlashCommandHandler
SLASH_AUTOLOOTSPECSWAP1 = "/autolootspecswap"
SLASH_AUTOLOOTSPECSWAP2 = "/alss"

